package TodoListApp.GUI_UserInterface;

import TodoListApp.Domain.ProgrammSystem;

public class Userverwalter {

	private ProgrammSystem system;
	private GUI_UserInterface user;
	private GUI_addTask taskHinziFuegenFenster;
	private RemoveTask taskLöschenFenster;
	private MarkTask markTaskFenster;
	private int index = 0;

	public Userverwalter() {
		this.system = new ProgrammSystem();
		this.user = new GUI_UserInterface();
		this.taskHinziFuegenFenster = new GUI_addTask();
		this.taskLöschenFenster = new RemoveTask();
		this.markTaskFenster = new MarkTask();

		// Buttons User:
		user.getAddTask().addActionListener(e -> taskAddFenster());
	
		taskHinziFuegenFenster.getSubmitTask().addActionListener(e ->addTask()); 
		
		markTaskFenster.getMarkTaskButton().addActionListener(e -> markTaskAsDone());
		taskLöschenFenster.getRemoveTaskButton().addActionListener(e-> removeTask());
		user.getTaskDone().addActionListener(e ->zeigeMarkTaskFenster());
		
		user.getZeigeAlleTasks().addActionListener(e -> showAllTasks());
		user.getClear().addActionListener(e -> clearTextArea());
		user.getRemoveTask().addActionListener(e -> removeTaskFenster());

	}

	public void taskAddFenster() {
		taskHinziFuegenFenster.zeigeFensterAddTask();

	}

	public void addTask(){

		String title = taskHinziFuegenFenster.getTasktitle().getText();
		String beschreibung = taskHinziFuegenFenster.getTaskBeschreibung().getText();
		String priorität;
		if (taskHinziFuegenFenster.getHoch().isSelected())
			priorität = "hoch";
		else if (taskHinziFuegenFenster.getMittel().isSelected())
			priorität = "mittle";
		else if (taskHinziFuegenFenster.getNiedrig().isSelected())
			priorität = "niedrig";
		else
			priorität = "niedrig";

		system.addTask(title, beschreibung, priorität);
		taskHinziFuegenFenster.resetButtons();
		taskHinziFuegenFenster.showInfo("Neuer Task wurde Erfolgreich hinzugefügt!");
	}

	public void showAllTasks() {
		if (system.showAllTasks().size() == 0) 
			user.showInfo("Momentan befinden sich keine Taks");
		
		else if (index >= system.showAllTasks().size()) 
			user.showInfo("Es gibt keine Tasks mehr!");
			
		else {
			while (index < system.showAllTasks().size()) {
				user.getAllTasksArea().append(system.showAllTasks().get(index++));
				user.getAllTasksArea().append("\n");
			}
		}
		
	}
	
	public void removeTaskFenster() {
		taskLöschenFenster.zeigeFenster();
	}
	
	public void removeTask() {
		String title = taskLöschenFenster.getRemoveTaskEingabe().getText();
		if (system.removeTask(title)) {
			taskLöschenFenster.showInfo("Task erfolgreich gelöscht");
			clearTextArea();
			showAllTasks();
		}
		else
			taskLöschenFenster.showError("Task ist  nicht auf der Liste");
	}
	
	public void clearTextArea() {
		if (user.getAllTasksArea().getText().isEmpty())
			user.showInfo("Ist bereits leer!");
			
		user.getAllTasksArea().setText("");
		index = 0;
	}
	
	public void zeigeMarkTaskFenster() {
		markTaskFenster.zeigeFenster();
	}
	
	public void markTaskAsDone() {
		String title = markTaskFenster.getMarkTaskEingabe().getText();

		if (title.isEmpty())
			markTaskFenster.showError("Sie müssen Title eingeben");
		else if (system.markTaskAsDone(title)) {
			markTaskFenster.showInfo("Task ist als Gemacht makiert");
			clearTextArea();
			showAllTasks();
		}
	}
}

